<template>
    <component :is="layout">
        <router-view />
    </component>

    <teleport to="body">
        <FullPageLoading />
    </teleport>
</template>

<script>
import { computed, provide } from "vue";
import { useRoute } from "vue-router";
import { PUBLIC_LAYOUT } from "@/constants";
import store from "@/store";

import FullPageLoading from "@/components/loading/FullPageLoading.vue";

export default {
    components: {
        FullPageLoading
    },
    setup() {
        // store
        provide("store", store);

        const route = useRoute();

        return {
            layout: computed(
                () => (route.meta.layout || PUBLIC_LAYOUT) + "-layout"
            )
        };
    }
};
</script>
